﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Threading.Tasks;
using Radzen;
using Radzen.Blazor;
using System.Net.Http;

namespace Test.Pages
{
    public partial class TestcheckboxComponent
    {
        public List<int> cols { get; set; } = new List<int>();

        public IEnumerable<IDictionary<string, object>> dataAll { get; set; }

        public IEnumerable<IDictionary<string, object>> data { get; set; }

        public IDictionary<string, Type> columns { get; set; }


        protected async Task aaa()
        {
            await base.OnInitializedAsync();

            columns = new Dictionary<string, Type>()
        {
            { "EmployeeID", typeof(int) },
            { "FirstName", typeof(string) },
            { "LastName", typeof(string) },
        };

            data = Enumerable.Range(0, 20).Select(i =>
            {
                var row = new Dictionary<string, object>();

                foreach (var column in columns)
                {
                    if(column.Value == typeof(int))
                    {
                        row.Add(column.Key, i);
                    }else if (column.Value == typeof(string))
                    {
                        row.Add(column.Key, $"{column.Key}{i}");
                    }
                }

                return row;
            });
        }

        public string GetColumnPropertyExpression(string name, Type type)
        {
            var expression = $@"it[""{name}""].ToString()";
            return type == typeof(int) ? $"int.Parse({expression})" : expression;
        }


        protected async Task load()
        {
            //var uri = new Uri("https://services.radzen.com/odata/Northwind/Employees")
            //.GetODataUri();

            //var response = await new HttpClient().SendAsync(new HttpRequestMessage(HttpMethod.Get, uri));

            //var result = await response.ReadAsync<ODataServiceResult<IDictionary<string, object>>>();

            //data = result.Value.AsODataEnumerable();

            //System.Diagnostics.Debug.WriteLine(data.Count());


            //List<IDictionary<string, object>> aaa = new List<IDictionary<string, object>>();
            //for (int i = 0; i < 5; i++)
            //{
            //    cols.Add(i);
            //}           

            //for (int j = 0; j < 2; j++)
            //{
            //    IDictionary<string, object> bbb = new Dictionary<string, object>();
            //    bbb.Add("id", Int32.Parse("13"));
            //    bbb.Add("name", (string)(j+"123"));
            //    //for (int i = 0; i < 5; i++)
            //    //{
            //    //    bbb.Add(i.ToString(), false);
            //    //}

            //    aaa.Add(bbb);
            //}
            //var sss = aaa.AsEnumerable();
            //dataAll = sss;
            //System.Diagnostics.Debug.WriteLine(dataAll.Count());
            
        }

        public async Task LoadData()
        {
            var uri = new Uri("https://services.radzen.com/odata/Northwind/Employees");

            var response = await new HttpClient().SendAsync(new HttpRequestMessage(HttpMethod.Get, uri));

            var result = await response.ReadAsync<ODataServiceResult<IDictionary<string, object>>>();

            data = result.Value.AsODataEnumerable();

        }

        public async Task changeCheckbox(bool value, IDictionary<string, object> row,int col)
        {
            if (value)
            {
                row[col.ToString()] = true;
            }
            else
            {
                row[col.ToString()] = false;
            }
        }
    }
}
